#include <ros/ros.h>
#include <sensor_msgs/PointCloud2.h>
#include <sensor_msgs/CompressedImage.h>
#include <sensor_msgs/Image.h>
#include <std_msgs/Bool.h>
#include <std_msgs/String.h>
#include <geometry_msgs/PoseArray.h>
#include <geometry_msgs/PoseStamped.h>
#include <cmath>
#include <math.h>//ragian
#include <iostream>
#include <string>
#include <tf/transform_datatypes.h>
#define PI 3.141592653589793

#include <fstream>
#include <string>
#include <cstdlib>
#include <obstacle_comparison/QRCordinate.h>
#include <obstacle_comparison/QRCordinateArray.h>

using namespace std;

class Obstacle_comparison{
    private:
        ros::NodeHandle nh;
        ros::Subscriber coordinate_sub;/*QRR[h̍W󂯎TuXNCo[*/
        ros::Publisher  trigger_pub ;/**gK[o͂pubV[*/
        std::ifstream reading_file;
        std::string filename,filename_yaml,output_filename;
        std_msgs::Bool trigger;
        double threshold;/* 臒l*/
	obstacle_comparison::QRCordinate obstaclecordinate;
	obstacle_comparison::QRCordinateArray qrworldcordinate;
        //obstacle_comparison::QRCordinate data;/*JX^bZ[W QRR[h̍Wivectorj*/
        //bool trigger; /*gK[NĂtO*/
        std::vector<std::vector<std::string>> obstacledata;
        double threshold_distance,thresholddistance;
        bool check_flag;
    public:
        Obstacle_comparison();
        void setup();
        void mainloop();
        void compare();
        double calculate_distance(double x1,double y1, double x2, double y2);
        void geometry_quat_to_rpy(double& roll, double& pitch, double& yaw, geometry_msgs::Quaternion geometry_quat);
        void file_output();
        void file_output2();
        void file_input();
        void excute_roslaunchfile();
        //callback
        void obstaclepose_cb(const obstacle_comparison::QRCordinateArray input);

};
Obstacle_comparison::Obstacle_comparison(){
    //pubV[ݒ
    trigger_pub = nh.advertise< std_msgs::Bool >("trigger", 1000);
    //TuXNCo[ݒ
    coordinate_sub = nh.subscribe ("qrpose", 10, &Obstacle_comparison::obstaclepose_cb,this);
    //臒lݒ
    
    filename = "/home/test/sample.csv";

}
void Obstacle_comparison::obstaclepose_cb(const obstacle_comparison::QRCordinateArray input){
    //TuXNCo[ݒ
    qrworldcordinate =input;
    //gK[tO = false
    check_flag=true;
}
void Obstacle_comparison::file_input(){
    
    //threshold_distance;
    trigger.data=false;
    //t@Copen
    std::ifstream inputFile(filename);
    if (!inputFile.is_open())
    {
        std::cerr << "Error opening file:"<<filename<< std::endl;

    }

    std::string line;
    while (std::getline(inputFile, line))
    {
        std::vector<std::string> rowData;
        std::istringstream lineStream(line);
        std::string cell;
        std::cout << " line:"<<line << std::endl;
        while (std::getline(lineStream, cell, ','))
        {
            rowData.push_back(cell);
        }

        obstacledata.push_back(rowData);
    }

    inputFile.close();


}
void Obstacle_comparison::setup(){
    threshold_distance=1.0;
    ros::NodeHandle pnh("~");
    pnh.getParam("thresholddistance", thresholddistance);
    pnh.getParam("filename", filename_yaml);
    pnh.getParam("outputfilename", output_filename);
    
    //ros::param::get("thresholddistance",thresholddistance);
    //ROS_INFO("threshold_distance %f",thresholddistance);  
    //std::cout<<"threshold_distance:"<<thresholddistance<<std::endl;
    //ros::param::get("filename",filename_yaml);
    //std::cout<<"filename_yaml:"<<filename_yaml<<std::endl;
    //ROS_INFO(filename_yaml);  
    filename=filename_yaml;
    threshold_distance=thresholddistance;
    file_input();
    //ǂݍݗpt@CpXݒ
    check_flag=false;
}
void Obstacle_comparison::file_output(){
    std::ofstream file(filename);
    
    if (file.is_open()) {
        for (const std::vector<std::string>& row : obstacledata) {
            for (size_t i = 0; i < row.size(); ++i) {
                file << row[i];
                if (i < row.size() - 1) {
                    file << ",";
                }
            }
            file << std::endl;
        }
        file.close();
    }
    std::cout<<""<<std::endl;
}
void Obstacle_comparison::file_output2(){
    std::ofstream file(output_filename);
    
    if (file.is_open()) {
        for (const std::vector<std::string>& row : obstacledata) {
            /*for (size_t i = 0; i < row.size()-4; ++i) {
            
                if (i > row.size() - 5) {
                    double rpy[3];
                    geometry_msgs::Quaternion geometry_quat;
                    geometry_quat.x=std::stod(row[4]);
                    geometry_quat.y=std::stod(row[5]);
                    geometry_quat.z=std::stod(row[6]);
                    geometry_quat.w=std::stod(row[7]);
                    geometry_quat_to_rpy(rpy[0],rpy[1],rpy[2],geometry_quat);
                    file <<rpy[0]<<","<<rpy[1]<<","<<rpy[2];
                }
                else{
                    file << row[i]<< ",";
                }
            }*/
            double rpy[3];
            geometry_msgs::Quaternion geometry_quat;
            geometry_quat.x=std::stod(row[4]);
            geometry_quat.y=std::stod(row[5]);
            geometry_quat.z=std::stod(row[6]);
            geometry_quat.w=std::stod(row[7]);
            geometry_quat_to_rpy(rpy[0],rpy[1],rpy[2],geometry_quat);
            file <<row[0]<< ","<<row[1]<< ","<<row[2]<< ","<<row[3]<< ",";
            file <<rpy[0]<<","<<rpy[1]<<","<<rpy[2];

            file << std::endl;
        }
        file.close();

    }
    std::cout<<""<<std::endl;
}
double Obstacle_comparison::calculate_distance(double x1,double y1, double x2, double y2){
	
	return sqrt( pow(x1 -x2, 2) + pow(y1 -y2, 2) );
}
void Obstacle_comparison::geometry_quat_to_rpy(double& roll, double& pitch, double& yaw, geometry_msgs::Quaternion geometry_quat){

        //tf::Quaternion quat;
        //quaternionMsgToTF(geometry_quat, quat);
        //tf::Matrix3x3(quat).getRPY(roll, pitch, yaw);  //rpy are Pass by Reference
        float q0q0 = geometry_quat.w * geometry_quat.w;
	float q1q1 = geometry_quat.x * geometry_quat.x;
	float q2q2 = geometry_quat.y * geometry_quat.y;
	float q3q3 = geometry_quat.z * geometry_quat.z;
	float q0q1 = geometry_quat.w * geometry_quat.x;
	float q0q2 = geometry_quat.w * geometry_quat.y;
	float q0q3 = geometry_quat.w * geometry_quat.z;
	float q1q2 = geometry_quat.x * geometry_quat.y;
	float q1q3 = geometry_quat.x * geometry_quat.z;
	float q2q3 = geometry_quat.y * geometry_quat.z;

        roll = atan2f((2.f * (q2q3 + q0q1)), (q0q0 - q1q1 - q2q2 + q3q3));
        pitch = -asinf((2.f * (q1q3 - q0q2)));
        yaw = atan2f((2.f * (q1q2 + q0q3)), (q0q0 + q1q1 - q2q2 - q3q3));
}

void Obstacle_comparison::excute_roslaunchfile(){

    // [`t@CsR}h𐶐
    const char *roslaunch_command = "roslaunch railposition railposition.launch &";
    
    // [`t@Cs
    int result = std::system(roslaunch_command);
    
    if (result == 0) {
        // ̏
        std::cout << "roslaunch succeeded." << std::endl;
    } else {
        // G[̏
        std::cerr << "roslaunch failed." << std::endl;
    }
    


}
void Obstacle_comparison::compare(){
    //Q̍Wr
        std::cout<<"compare:"<<std::endl;
        for(int qrnum=0 ; qrnum< qrworldcordinate.data.size() ; qrnum++){
            obstaclecordinate=qrworldcordinate.data[qrnum];
            std::vector<std::string> data;
            bool flag ;/*ȂƂmF*/
            for(int i= 0 ; i < obstacledata.size() ; i++){
            //std::cout<<"compare:i "<<i<<std::endl;
                if(obstaclecordinate.qrdata == obstacledata[i][0] ){
                    //Qcsvt@C̍W̒(֐)
                    double x1 = obstaclecordinate.pose.position.x;
                    double y1 = obstaclecordinate.pose.position.y;
                    double x2 = std::stod(obstacledata[i][1]);
                    double y2 = std::stod(obstacledata[i][2]);
                
                    double distance = calculate_distance(x1 , y1 , x2 , y2);
                    std::cout<<"obstacle code "<<obstaclecordinate.qrdata
                          <<" threshold_distance:"<<threshold_distance<<" distance:"<<distance<<std::endl;
                    if(threshold_distance < distance){
                        //CSVt@C̍WɌ݂̏Q̍W
                        std::cout<<"obstacle code "<<obstaclecordinate.qrdata<<" cordinate update"<<std::endl;
                        obstacledata[i][1]= std::to_string(obstaclecordinate.pose.position.x);
                        obstacledata[i][2]= std::to_string(obstaclecordinate.pose.position.y);
                        obstacledata[i][3]= std::to_string(obstaclecordinate.pose.position.z);
                        obstacledata[i][4]= std::to_string(obstaclecordinate.pose.orientation.x);
                        obstacledata[i][5]= std::to_string(obstaclecordinate.pose.orientation.y);
                        obstacledata[i][6]= std::to_string(obstaclecordinate.pose.orientation.z);
                        obstacledata[i][7]= std::to_string(obstaclecordinate.pose.orientation.w);
                    
                        //gK[vbVtOON
                        trigger.data=true;
                    }
                    break;
                
                }
                if(i==obstacledata.size()-1){
                   data.push_back( obstaclecordinate.qrdata);
                   data.push_back( std::to_string(obstaclecordinate.pose.position.x));
                   data.push_back( std::to_string(obstaclecordinate.pose.position.y));
                   data.push_back( std::to_string(obstaclecordinate.pose.position.z));
                   data.push_back( std::to_string(obstaclecordinate.pose.orientation.x) );
                   data.push_back( std::to_string(obstaclecordinate.pose.orientation.y) );
                   data.push_back( std::to_string(obstaclecordinate.pose.orientation.z) );
                   data.push_back( std::to_string(obstaclecordinate.pose.orientation.w) );     
                }
            
                //
            }
        }
        if(qrworldcordinate.data.size() < obstacledata.size()){
            for(int i= 0 ; i < obstacledata.size() ; i++){
               //std::cout<<"i:"<<i<<std::endl;
                for(int qrnum=0 ; qrnum< qrworldcordinate.data.size() ; qrnum++){
                    //std::cout<<"qrnum:"<<qrnum<<std::endl;
                    obstaclecordinate=qrworldcordinate.data[qrnum];
                    //std::cout<<"file:"<<obstacledata[i][0]<<" subscriver:"<<obstaclecordinate.qrdata<<std::endl; 
                    if(obstaclecordinate.qrdata == obstacledata[i][0] )break;
                    obstacledata.erase(obstacledata.begin() + i);
                    i--;
                    trigger.data=true;
                    //std::cout<<"- i:"<<i<<std::endl;

                }
            }
        }
    	//CSVt@Ci[Ăz̍Ōɒǉ鏈
    	/*push_back()*/
    	//obstacledata.push_back(data);
    //}
}
void Obstacle_comparison::mainloop(){

    ros::Rate rate(1.0);
    std::cout<<"mainloop 0"<<std::endl;

    while(ros::ok())
    {
      //std::cout<<"1"<<std::endl;

      ros::spinOnce();
      rate.sleep();
      //W̔r
      //std::cout<<"2"<<std::endl;
      if(check_flag==true)compare();//Wr̊֐
      check_flag=false;
      if(trigger.data==true){
        //trigger_pub.publish(trigger);
        std::cout<<"start slam"<<std::endl;
        file_output2();
        excute_roslaunchfile();
        
        trigger.data=false;
      }
        
    }
    file_output();

    std::cout<<"end"<<std::endl;
}

int main (int argc, char** argv)
{
    // Initialize ROS
    ros::init (argc, argv, "obstaclecoordinate_comparison");
    ROS_INFO("ROS Init");
    Obstacle_comparison obstacle_comparison;
    obstacle_comparison.setup();
    obstacle_comparison.mainloop();
}
