#include <ros/ros.h>
#include <sensor_msgs/PointCloud2.h>
#include <sensor_msgs/CompressedImage.h>
#include <sensor_msgs/Image.h>
#include <std_msgs/Bool.h>
#include <std_msgs/String.h>
#include <geometry_msgs/PoseArray.h>
#include <cmath>
#include <math.h>//ragian
#include <iostream>
#include <string>
#define PI 3.141592653589793

#include <fstream>
#include <string>

#include <obstacle_comparison/QRCordinate.h>

using namespace std;

class Obstacle_comparison_test{
    private:
        ros::NodeHandle nh;
        ros::Subscriber coordinate_sub;
        ros::Publisher  test_pub ;
	obstacle_comparison::QRCordinate obstaclecordinate;
        obstacle_comparison::QRCordinate data;
        bool check_flag;
    public:
        Obstacle_comparison_test();
        void setup();
        void mainloop();
        //callback
        void obstaclepose_cb(const obstacle_comparison::QRCordinate input);

};
Obstacle_comparison_test::Obstacle_comparison_test(){
    //pubV[ݒ
    test_pub = nh.advertise< obstacle_comparison::QRCordinate >("test_pub", 1000);
    //TuXNCo[ݒ
    coordinate_sub = nh.subscribe ("qrpose", 10, &Obstacle_comparison_test::obstaclepose_cb,this);
    //臒lݒ
}
void Obstacle_comparison_test::obstaclepose_cb(const obstacle_comparison::QRCordinate input){
    //TuXNCo[ݒ
    obstaclecordinate =input;
    //gK[tO = false
    check_flag=true;
}

void Obstacle_comparison_test::setup(){
    //ros::param::get("filename",filename);
    //ROS_INFO(filename);  
   
    //ǂݍݗpt@CpXݒ
    check_flag=false;
}

void Obstacle_comparison_test::mainloop(){

    ros::Rate rate(1.0);
    std::cout<<"mainloop 0"<<std::endl;

    while(ros::ok())
    {
      std::cout<<"1"<<std::endl;

      ros::spinOnce();
      rate.sleep();
      //W̔r
      data.qrdata="1";
      data.pose.position.x=1.0;
      data.pose.position.y=1.0;
      data.pose.position.z=1.0;
      data.pose.orientation.x=1.0;
      data.pose.orientation.y=1.0;
      data.pose.orientation.z=1.0;
      data.pose.orientation.w=1.0;  
      test_pub.publish(data);

    }

}

int main (int argc, char** argv)
{
    // Initialize ROS
    ros::init (argc, argv, "obstaclecoordinate_comparison");
    ROS_INFO("ROS Init");
    Obstacle_comparison_test obstacle_comparison_test;
    obstacle_comparison_test.setup();
    obstacle_comparison_test.mainloop();
}
